<template lang="pug">
  v-row(justify="center" align="center")
    v-col(cols="12" sm="8" md="6")
      v-card
        v-card-title(class="headline") Téléverseur
        v-spacer.ma-3
        v-card-text.pb-0
          v-select(outlined label="Choisis le type de carte" v-model="board" :items="boards" item-text="text" item-value="value" :hint="board")
          v-spacer.ma-6
          v-textarea(outlined v-model="code" label="Copies le code")
          template(v-if="message")
            v-alert.ma-0(
              text
              dense
              :type="message.type"
              icon="mdi-information"
              border="left"
            ) {{message.data}}
        v-card-actions.pa-6.ma-0
          v-spacer
          v-btn(
            color="primary"
            nuxt
            @click="push"
            :loading="pushing"
          ) Televerser
      v-spacer.ma-12
      v-card
        v-card-title(class="headline") Exemple de code
        v-card-text
          code void setup() { pinMode(LED_BUILTIN, OUTPUT); } void loop() { digitalWrite(LED_BUILTIN, HIGH); delay(1000); digitalWrite(LED_BUILTIN, LOW); delay(1000); }
</template>
<script>
import AvrgirlArduino from 'avrgirl-arduino'
export default {
  components: {
  },
  data () {
    return {
      avrgirl: null,
      hex: '',
      code: '',
      message: null,
      pushing: false,
      board: '',
      boards: [
        { text: 'Mega', value: 'arduino:avr:mega:cpu=atmega2560' },
        { text: 'Nano', value: 'arduino:avr:nano:cpu=atmega328' },
      ],
    }
  },
  mounted () {
    if ("serial" in navigator) {
      console.log('The Serial API is supported.');
      // The Serial API is supported.
    } else {
      console.log('The Serial API is NOT supported.');
    }
    this.pushing = false
    this.avrgirl = new AvrgirlArduino({
      board: 'mega',
      debug: true
    });
    // /dev/ttyACM0
    console.log(this.avrgirl);
  },
  methods: {
    async push (e) {
      console.log('push', e, this.code)
      this.pushing = true
      this.hex = await this.compile(this.code, this.board)
      console.log('push', this.hex)
      const $this = this
      if (this.hex) {
        this.avrgirl.flash(this.hex, function (error) {
          if (error) {
            $this.message = {
              data: 'Le téléversement a échoué.',
              type: 'error',
              icon: 'mdi-error'
            }
            console.error('push', error)
          } else {
            $this.message = {
              data: 'le téléversement est un succès !',
              type: 'success',
              icon: 'mdi-done'
            }
            console.info('push', 'done.')
          }
          $this.pushing = false
          return true
        })
      } else {
        this.pushing = false
        return false
      }
    },
    async compile (code, board) {
      const url = process.env.ENV === 'dev' ? 'http://' + process.env.COMPILER : 'https://' + process.env.COMPILER
      // const url = 'http://' + process.env.COMPILER
      console.log(process.env.ENV, url)
      if (!board || board === '') {
        this.message = {
          data: 'Il faut choisir un type de carte !',
          type: 'error',
          icon: 'mdi-error'
        }
        return false
      }
      if (!code || code === '') {
        this.message = {
          data: 'le code est manquant !',
          type: 'error',
          icon: 'mdi-error'
        }
        return false
      }
      const data = {
        'data': code,
        'boardName': this.board // Should be from a select
      }
      try {
        let resp = await this.$axios.post(url, data)
        console.info('compile', 'done.')
        return Buffer(resp.data.hex)
      } catch (e) {
        this.message = {
          data: 'la compilation a échoué.',
          type: 'error'
        }
        console.log('compile', e.response)
      }
    },
  }
}
</script>
